// hlavickove subory *******************************************************
// systemove funkcie
#include <math.h>

// vlastny .h subor
#include "m3dmath.h"

// konstruktor *************************************************************
m3dmath::m3dmath()
{

}

// destruktor **************************************************************
m3dmath::~m3dmath()
{

}

// vypocet prvkov 3-rozmerneho vektora *************************************
tVec3 m3dmath::Vector(tVec3 P1,tVec3 P2)
{
 vector_result.x=P2.x-P1.x;
 vector_result.y=P2.y-P1.y;
 vector_result.z=P2.z-P1.z;

 return vector_result; // vysledok=P2 - P1
}

// sucet vektorov **********************************************************
tVec3 m3dmath::AddVector(tVec3 V1,tVec3 V2)
{
 vector_result.x=V1.x+V2.x;
 vector_result.y=V1.y+V2.y;
 vector_result.z=V1.z+V2.z;

 return vector_result; // vysledok=V1 + V2
}

// delenie vektora skalarom ************************************************
tVec3 m3dmath::DivVectorByScalar(tVec3 V,float S)
{
 if (S==0.0f) S=1.0f;

 vector_result.x=V.x/S;
 vector_result.y=V.y/S;
 vector_result.z=V.z/S;

 return vector_result; // vysledok=V / S
}

// skalarny sucin dvoch vektorov *******************************************
float m3dmath::Dot(tVec3 V1,tVec3 V2)
{
 scalar_result=(V1.x*V2.x)+(V1.y*V2.y)+(V1.z*V2.z);

 return scalar_result; // vysledok=V1 . V2
}

// vektorovy sucin dvoch vektorov ******************************************
tVec3 m3dmath::Cross(tVec3 V1,tVec3 V2)
{
 vector_result.x=((V1.y*V2.z)-(V1.z*V2.y));
 vector_result.y=((V1.z*V2.x)-(V1.x*V2.z));
 vector_result.z=((V1.x*V2.y)-(V1.y*V2.x));

 return vector_result; // vysledok=V1 x V2
}

// normalizacia normaly ****************************************************
tVec3 m3dmath::Normalize(tVec3 N)
{
 magnitude=(float) (sqrt(N.x*N.x+N.y*N.y+N.z*N.z));

 vector_result=DivVectorByScalar(N,magnitude);

 return vector_result; // vysledok=N / magnitude
}
