#ifndef _MFRUSTUM_H_
#define _MFRUSTUM_H_

// trieda premennych a funkcii (objektov) pre Frustum Culling
class mFrustum {
public:
 mFrustum();          // konstruktor
 virtual ~mFrustum(); // destruktor

 // vypocet rovnic stran (rovin) Frustum - vykonava sa vzdy
 void FrustumUpdate(void);

 // test, ci je bod vo Frustum X,Y,Z - 3D suradnice bodu
 bool PointInFrustum(GLfloat X,GLfloat Y,GLfloat Z);
 // test, ci je trojuholnik vo Frustum
 bool TriangleInFrustum(GLfloat X1,GLfloat Y1,GLfloat Z1,
                        GLfloat X2,GLfloat Y2,GLfloat Z2,
                        GLfloat X3,GLfloat Y3,GLfloat Z3);
 // test, ci je gula vo Frustum X,Y,Z - stred gule,R - polomer gule
 bool SphereInFrustum(GLfloat X,GLfloat Y,GLfloat Z,GLfloat R);
 // test, ci je kocka vo Frustum X,Y,Z - stred kocky, S - 1/2 velkosti
 bool CubeInFrustum(GLfloat X,GLfloat Y,GLfloat Z,GLfloat S);
 // test, ci je kocka vo Frustum X,Y,Z - min. a max. hodnoty v danych smeroch
 bool CubeInFrustum2(GLfloat X1,GLfloat X2,
                     GLfloat Y1,GLfloat Y2,
                     GLfloat Z1,GLfloat Z2);
private:
 // velkost (magnituda) a reciprocna hodnota velkosti (magnitudy) vektora
 GLfloat magn,recip_magn;

 GLfloat proj[16]; // prvky projekcnej matice
 GLfloat modv[16]; // prvky modelview matice
 GLfloat clip[16]; // pre vypocet orezavacich rovin

 // A,B,C,D prvky stran (rovin) Frustum
 GLfloat plane[6][4];

 GLuint i; // pomocna premenna

 // normalizacia prvkov rovnice strany (roviny) Frustum
 void NormalizePlane(GLfloat F[6][4],GLuint S);
};

#endif
