#ifndef _MBACKEND_H_
#define _MBACKEND_H_

// praca s 3ds subormi
#include "common/m3ds.h"

// trojuholnik
#include "mFrontend.h"

// trieda premennych a funkcii (objektov) pre pracu s OpenGL objektami
class mObject {
public:
 // konstruktor
 mObject();
 // destruktor
 virtual ~mObject();

 m3ds m3ds_obj; // nacitavanie 3ds modelov

 void plane(GLfloat SIZE,GLfloat STEP); // rovinna plocha

 // vyber udajov o 3ds modely a ich presun do zoznamu trojuholnikov
 int extract_terrain(m3ds *OBJ,mTriangle *T,GLuint DTEX,GLuint OL);
 // vyber udajov o 3ds dummy objektoch
 int extract_dummy(m3ds *OBJ);
 // vyber udajov o 3ds modeloch a ich presun do zoznamu trojuholnikov
 int extract_entities(m3ds *OBJ,mTriangle *T);

 // vykreslenie matice 128x128
 int mat128x128_draw(void);

 tVec3 avatar_pos; // poloha avatara nacitana z 3ds suboru
private:
 GLuint obj_id; // pomocna premenna

 GLfloat a,b,c; // pomocne premenne
 GLuint i,j;    // pomocne premenne

 m3dmath mm; // pre pracu s matematikou

 tMatVT *mat128x128;  // matica 128x128 vrcholov + texturovacich suradnic
 GLuint ai,bi,ci,di;  // pomocne premenne
 GLuint ol;           // uroven optimalizacie matice 128x128

 GLuint i1,i2,i3;      // pomocne premenne - indexy do pola vrcholov
 GLuint id1,id2;       // pomocne premenne - identifikatory textur
 tVec4 col;            // pomocna premenna - farba
 tVec3 n1,n2,n3;       // pomocne premenne - normaly
 tVec3 v1,v2,v3,v4,v5; // pomocne premenne - suradnice vrcholov
 tVec2 t1,t2,t3;       // pomocne premenne - texturovacie suradnice

 tVec3 p1,p2,p3,p4; // pomocne vektory

 // optimalizacia matice 128x128
 int mat128x128_optimize(GLuint OL);
};

#endif
